diff --git binutils-2.20.1.orig/gas/config/tc-msp430.c binutils-2.20.1/gas/config/tc-msp430.c
index 0ccf4db..4784c05 100644
--- binutils-2.20.1.orig/gas/config/tc-msp430.c
+++ binutils-2.20.1/gas/config/tc-msp430.c
@@ -23,7 +23,6 @@
 
 #include <limits.h>
 
-#define PUSH_1X_WORKAROUND
 #include "as.h"
 #include "subsegs.h"
 #include "opcode/msp430.h"
@@ -69,6 +68,7 @@
 
 int msp430_enable_relax;
 int msp430_enable_polys;
+int msp430x_repeats;    // It's not a right way to use global variable, but I don't know other way how to do it
 
 /* GCC uses the some condition codes which we'll
    implement as new polymorph instructions.
@@ -99,12 +99,13 @@ int msp430_enable_polys;
    Also, we add 'jump' instruction:
    jump	UNCOND	-> jmp		br lab
 
-   They will have fmt == 4, and insn_opnumb == number of instruction.  */
+   They will have opcode_format() == FMT_EMULATED_POLYMORPH_JUMP, 
+   and opcode_variant() == number of instruction.  */
 
 struct rcodes_s 
 {
   char * name;
-  int    index;	/* Corresponding insn_opnumb.  */
+  int    index;	/* Corresponding opcode_variant().  */
   int    sop;	/* Opcode if jump length is short.  */
   long   lpos;	/* Label position.  */
   long   lop0;	/* Opcode 1 _word_ (16 bits).  */
@@ -143,7 +144,7 @@ static struct rcodes_s msp430_rcodes[] =
 struct hcodes_s 
 {
   char * name;	
-  int    index;		/* Corresponding insn_opnumb.  */
+  int    index;		/* Corresponding opcode_variant().  */
   int    tlab;		/* Number of labels in short mode.  */
   int    op0;		/* Opcode for first word of short jump.  */
   int    op1;		/* Opcode for second word of short jump.  */
@@ -237,107 +238,278 @@ struct mcu_type_s
   int mach;
 };
 
-#define MSP430_ISA_11   11
-#define MSP430_ISA_110	110
-#define MSP430_ISA_12   12
-#define MSP430_ISA_13   13
-#define MSP430_ISA_14   14
-#define MSP430_ISA_15   15
-#define MSP430_ISA_16   16
-#define MSP430_ISA_21   21
-#define MSP430_ISA_31   31
-#define MSP430_ISA_32   32
-#define MSP430_ISA_33   33
-#define MSP430_ISA_41   41
-#define MSP430_ISA_42   42
-#define MSP430_ISA_43   43
-#define MSP430_ISA_44   44
-
-#define CHECK_RELOC_MSP430 		((imm_op || byte_op)?BFD_RELOC_MSP430_16_BYTE:BFD_RELOC_MSP430_16)
-#define CHECK_RELOC_MSP430_PCREL	((imm_op || byte_op)?BFD_RELOC_MSP430_16_PCREL_BYTE:BFD_RELOC_MSP430_16_PCREL)
-
-static struct mcu_type_s mcu_types[] =
+enum
 {
-  {"msp1",        MSP430_ISA_11, bfd_mach_msp11},
-  {"msp2",        MSP430_ISA_14, bfd_mach_msp14},
-  {"msp430x110",  MSP430_ISA_11, bfd_mach_msp11},
-  {"msp430x112",  MSP430_ISA_11, bfd_mach_msp11},
-  {"msp430x1101", MSP430_ISA_110, bfd_mach_msp110},
-  {"msp430x1111", MSP430_ISA_110, bfd_mach_msp110},
-  {"msp430x1121", MSP430_ISA_110, bfd_mach_msp110},
-  {"msp430x1122", MSP430_ISA_11, bfd_mach_msp110},
-  {"msp430x1132", MSP430_ISA_11, bfd_mach_msp110},
-
-  {"msp430x122",  MSP430_ISA_12, bfd_mach_msp12},
-  {"msp430x123",  MSP430_ISA_12, bfd_mach_msp12},
-  {"msp430x1222", MSP430_ISA_12, bfd_mach_msp12},
-  {"msp430x1232", MSP430_ISA_12, bfd_mach_msp12},
-
-  {"msp430x133",  MSP430_ISA_13, bfd_mach_msp13},
-  {"msp430x135",  MSP430_ISA_13, bfd_mach_msp13},
-  {"msp430x1331", MSP430_ISA_13, bfd_mach_msp13},
-  {"msp430x1351", MSP430_ISA_13, bfd_mach_msp13},
-  {"msp430x147",  MSP430_ISA_14, bfd_mach_msp14},
-  {"msp430x148",  MSP430_ISA_14, bfd_mach_msp14},
-  {"msp430x149",  MSP430_ISA_14, bfd_mach_msp14},
-
-  {"msp430x155",  MSP430_ISA_15, bfd_mach_msp15},
-  {"msp430x156",  MSP430_ISA_15, bfd_mach_msp15},
-  {"msp430x157",  MSP430_ISA_15, bfd_mach_msp15},
-  {"msp430x167",  MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x168",  MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x169",  MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x1610", MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x1611", MSP430_ISA_16, bfd_mach_msp16},
-  {"msp430x1612", MSP430_ISA_16, bfd_mach_msp16},
-
-  {"msp430x2101", MSP430_ISA_21, bfd_mach_msp21},
-  {"msp430x2111", MSP430_ISA_21, bfd_mach_msp21},
-  {"msp430x2121", MSP430_ISA_21, bfd_mach_msp21},
-  {"msp430x2131", MSP430_ISA_21, bfd_mach_msp21},
+  CORE_MASK = 0x3,
+  CPU4_BUG = 1 << 2,    // push #4, push #8 cannot use CG
+  CPU7_BUG = 1 << 3,    // CALL and PUSH with @SP+, @SP, and X(SP) uses the SP to calculate the address, then decrements it
+  CPU8_BUG = 1 << 4,    // using odd values with SP
+  CPU11_BUG = 1 << 5,   // When addressing the program counter (PC) in register mode and the PC is the destination, the
+                        // status register (SR) may be erroneous. The instructions BIS, BIC, and MOV do not affect SR contents.
+  CPU12_BUG = 1 << 6,   // Any instruction immediately following a CMP(.B) or BIT(.B) instruction where the PC is the 
+                        // destination address using register mode is ignored or erroneously executed. 
+                        // *** we can issue warning if any instruction other than nop follows cmp(.b) or bit(.b) ***
+  CPU13_BUG = 1 << 7,   // Performing arithmetic operations with the status register as the destination address does not 
+                        // update the status register as intended. The result in SR can be invalid, leading to erroneous low-
+                        // power mode entry. *** we can issue warning ***
+  CPU16_BUG = 1 << 8,   // With indexed addressing mode and instructions calla, mova and bra
+                        // it is not possible to reach memory above 64k if the register content is <64k. 
+};
+static core_t msp430_core( struct mcu_type_s const * mcu )
+{
+  return (core_t)(mcu->isa & CORE_MASK);
+}
+
+#define MSP430_ISA_11           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_110          (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_12           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_13           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_14           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_15           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_16           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_20           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_21           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_21x1         (CORE_430 | CPU4_BUG|CPU11_BUG|CPU12_BUG|CPU13_BUG)
+#define MSP430_ISA_22           (CORE_430)
+#define MSP430_ISA_23           (CORE_430)
+#define MSP430_ISA_24           (CORE_430 | CPU8_BUG)
+#define MSP430_ISA_241          (CORE_430X | CPU7_BUG|CPU8_BUG|CPU16_BUG)
+#define MSP430_ISA_26           (CORE_430X | CPU7_BUG|CPU8_BUG|CPU16_BUG)
+#define MSP430_ISA_31           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_32           (CORE_430 | CPU4_BUG) 
+#define MSP430_ISA_33           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_41           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_42           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_43           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_44           (CORE_430 | CPU4_BUG)
+#define MSP430_ISA_46           (CORE_430X | CPU7_BUG|CPU8_BUG)
+#define MSP430_ISA_47           (CORE_430)
+#define MSP430_ISA_471          (CORE_430X)
+#define MSP430_ISA_54           (CORE_430X2)
+
+#define CHECK_RELOC_MSP430                  ((imm_op || op_width == BYTE_OP) ? BFD_RELOC_MSP430_16_BYTE : BFD_RELOC_MSP430_16)
+#define CHECK_RELOC_MSP430_PCREL            ((imm_op || op_width == BYTE_OP) ? BFD_RELOC_MSP430_16_PCREL_BYTE : BFD_RELOC_MSP430_16_PCREL)
+#define CHECK_RELOC_MSP430X_SRC             ((imm_op || op_width == BYTE_OP) ? BFD_RELOC_MSP430X_SRC_BYTE : BFD_RELOC_MSP430X_SRC)
+#define CHECK_RELOC_MSP430X_PCREL_SRC       ((imm_op || op_width == BYTE_OP) ? BFD_RELOC_MSP430X_PCREL_SRC_BYTE : BFD_RELOC_MSP430X_PCREL_SRC)
+#define CHECK_RELOC_MSP430X_DST             ((imm_op || op_width == BYTE_OP) ? BFD_RELOC_MSP430X_DST_BYTE : BFD_RELOC_MSP430X_DST)
+#define CHECK_RELOC_MSP430X_PCREL_DST       ((imm_op || op_width == BYTE_OP) ? BFD_RELOC_MSP430X_PCREL_DST_BYTE : BFD_RELOC_MSP430X_PCREL_DST)
+#define CHECK_RELOC_MSP430X_DST_2ND         ((imm_op || op_width == BYTE_OP) ? BFD_RELOC_MSP430X_DST_2ND_BYTE : BFD_RELOC_MSP430X_DST_2ND)
+#define CHECK_RELOC_MSP430X_PCREL_DST_2ND   ((imm_op || op_width == BYTE_OP) ? BFD_RELOC_MSP430X_PCREL_DST_2ND_BYTE : BFD_RELOC_MSP430X_PCREL_DST_2ND)
+
+static struct mcu_type_s const mcu_types[] =
+{
+  {"msp1",         MSP430_ISA_11,  bfd_mach_msp11},
+  {"msp2",         MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp3",         MSP430_ISA_46,  bfd_mach_msp46},
+  {"msp4",         MSP430_ISA_47,  bfd_mach_msp47},
+  {"msp5",         MSP430_ISA_471, bfd_mach_msp471},
+  {"msp6",         MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x110",   MSP430_ISA_11,  bfd_mach_msp11},
+  {"msp430x112",   MSP430_ISA_11,  bfd_mach_msp11},
+  {"msp430x1101",  MSP430_ISA_110, bfd_mach_msp110},
+  {"msp430x1111",  MSP430_ISA_110, bfd_mach_msp110},
+  {"msp430x1121",  MSP430_ISA_110, bfd_mach_msp110},
+  {"msp430x1122",  MSP430_ISA_11,  bfd_mach_msp110},
+  {"msp430x1132",  MSP430_ISA_11,  bfd_mach_msp110},
+
+  {"msp430x122",   MSP430_ISA_12,  bfd_mach_msp12},
+  {"msp430x123",   MSP430_ISA_12,  bfd_mach_msp12},
+  {"msp430x1222",  MSP430_ISA_12,  bfd_mach_msp12},
+  {"msp430x1232",  MSP430_ISA_12,  bfd_mach_msp12},
+
+  {"msp430x133",   MSP430_ISA_13,  bfd_mach_msp13},
+  {"msp430x135",   MSP430_ISA_13,  bfd_mach_msp13},
+  {"msp430x1331",  MSP430_ISA_13,  bfd_mach_msp13},
+  {"msp430x1351",  MSP430_ISA_13,  bfd_mach_msp13},
+  {"msp430x147",   MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x148",   MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x149",   MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x1471",  MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x1481",  MSP430_ISA_14,  bfd_mach_msp14},
+  {"msp430x1491",  MSP430_ISA_14,  bfd_mach_msp14},
+
+  {"msp430x155",   MSP430_ISA_15,  bfd_mach_msp15},
+  {"msp430x156",   MSP430_ISA_15,  bfd_mach_msp15},
+  {"msp430x157",   MSP430_ISA_15,  bfd_mach_msp15},
+  {"msp430x167",   MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x168",   MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x169",   MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x1610",  MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x1611",  MSP430_ISA_16,  bfd_mach_msp16},
+  {"msp430x1612",  MSP430_ISA_16,  bfd_mach_msp16},
+
+  {"msp430x2001",  MSP430_ISA_20,  bfd_mach_msp20},
+  {"msp430x2011",  MSP430_ISA_20,  bfd_mach_msp20},
+
+  {"msp430x2002",  MSP430_ISA_20,  bfd_mach_msp20},
+  {"msp430x2012",  MSP430_ISA_20,  bfd_mach_msp20},
+
+  {"msp430x2003",  MSP430_ISA_20,  bfd_mach_msp20},
+  {"msp430x2013",  MSP430_ISA_20,  bfd_mach_msp20},
+
+  {"msp430x2101",  MSP430_ISA_21x1,  bfd_mach_msp21},
+  {"msp430x2111",  MSP430_ISA_21x1,  bfd_mach_msp21},
+  {"msp430x2112",  MSP430_ISA_21,  bfd_mach_msp21},
+  {"msp430x2121",  MSP430_ISA_21x1,  bfd_mach_msp21},
+  {"msp430x2122",  MSP430_ISA_21,  bfd_mach_msp21},
+  {"msp430x2131",  MSP430_ISA_21x1,  bfd_mach_msp21},
+  {"msp430x2132",  MSP430_ISA_21,  bfd_mach_msp21},
+
+  /* 20101114: note that these chips are msp430g22XX, not msp430f22XX.
+   * There are no msp430f22XX with these familty codes.  Historically,
+   * the F-type chips are not compatible with the G-type chips in
+   * terms of flash size and address.  Since gcc does not distinguish
+   * chips by memory type (uses x instead of f or g), other chips
+   * cannot be supported. */
+  {"msp430x2201",  MSP430_ISA_22,  bfd_mach_msp22}, // VALUE-LINUE msp430g
+  {"msp430x2211",  MSP430_ISA_22,  bfd_mach_msp22}, // VALUE-LINUE msp430g
+  {"msp430x2221",  MSP430_ISA_22,  bfd_mach_msp22}, // VALUE-LINUE msp430g
+  {"msp430x2231",  MSP430_ISA_22,  bfd_mach_msp22}, // VALUE-LINUE msp430g
+
+  {"msp430x2232",  MSP430_ISA_22,  bfd_mach_msp22},
+  {"msp430x2234",  MSP430_ISA_22,  bfd_mach_msp22},
+  {"msp430x2252",  MSP430_ISA_22,  bfd_mach_msp22},
+  {"msp430x2254",  MSP430_ISA_22,  bfd_mach_msp22},
+  {"msp430x2272",  MSP430_ISA_22,  bfd_mach_msp22},
+  {"msp430x2274",  MSP430_ISA_22,  bfd_mach_msp22},
+
+  {"msp430x233",   MSP430_ISA_24,  bfd_mach_msp24},
+  {"msp430x235",   MSP430_ISA_24,  bfd_mach_msp24},
+  {"msp430x2330",  MSP430_ISA_23,  bfd_mach_msp23},
+  {"msp430x2350",  MSP430_ISA_23,  bfd_mach_msp23},
+  {"msp430x2370",  MSP430_ISA_23,  bfd_mach_msp23},
+
+  {"msp430x247",   MSP430_ISA_24,  bfd_mach_msp24},
+  {"msp430x2471",  MSP430_ISA_24,  bfd_mach_msp24},
+  {"msp430x248",   MSP430_ISA_24,  bfd_mach_msp24},
+  {"msp430x2481",  MSP430_ISA_24,  bfd_mach_msp24},
+  {"msp430x249",   MSP430_ISA_24,  bfd_mach_msp24},
+  {"msp430x2491",  MSP430_ISA_24,  bfd_mach_msp24},
+  {"msp430x2410",  MSP430_ISA_24,  bfd_mach_msp24},
+
+  {"msp430x2416",  MSP430_ISA_241, bfd_mach_msp241},
+  {"msp430x2417",  MSP430_ISA_241, bfd_mach_msp241},
+  {"msp430x2418",  MSP430_ISA_241, bfd_mach_msp241},
+  {"msp430x2419",  MSP430_ISA_241, bfd_mach_msp241},
   
-  {"msp430x311",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x312",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x313",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x314",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x315",  MSP430_ISA_31, bfd_mach_msp31},
-  {"msp430x323",  MSP430_ISA_32, bfd_mach_msp32},
-  {"msp430x325",  MSP430_ISA_32, bfd_mach_msp32},
-  {"msp430x336",  MSP430_ISA_33, bfd_mach_msp33},
-  {"msp430x337",  MSP430_ISA_33, bfd_mach_msp33},
-
-  {"msp430x412",  MSP430_ISA_41, bfd_mach_msp41},
-  {"msp430x413",  MSP430_ISA_41, bfd_mach_msp41},
-  {"msp430x415",  MSP430_ISA_41, bfd_mach_msp41},
-  {"msp430x417",  MSP430_ISA_41, bfd_mach_msp41},
-
-  {"msp430xE423", MSP430_ISA_42, bfd_mach_msp42},
-  {"msp430xE425", MSP430_ISA_42, bfd_mach_msp42},
-  {"msp430xE427", MSP430_ISA_42, bfd_mach_msp42},
-
-  {"msp430xW423", MSP430_ISA_42, bfd_mach_msp42},
-  {"msp430xW425", MSP430_ISA_42, bfd_mach_msp42},
-  {"msp430xW427", MSP430_ISA_42, bfd_mach_msp42},
-
-  {"msp430xG437", MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430xG438", MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430xG439", MSP430_ISA_43, bfd_mach_msp43},
-
-  {"msp430x435",  MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430x436",  MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430x437",  MSP430_ISA_43, bfd_mach_msp43},
-  {"msp430x447",  MSP430_ISA_44, bfd_mach_msp44},
-  {"msp430x448",  MSP430_ISA_44, bfd_mach_msp44},
-  {"msp430x449",  MSP430_ISA_44, bfd_mach_msp44},
+  {"msp430x2616",  MSP430_ISA_26,  bfd_mach_msp26},
+  {"msp430x2617",  MSP430_ISA_26,  bfd_mach_msp26},
+  {"msp430x2618",  MSP430_ISA_26,  bfd_mach_msp26},
+  {"msp430x2619",  MSP430_ISA_26,  bfd_mach_msp26},
+  
+  {"msp430x311",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x312",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x313",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x314",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x315",   MSP430_ISA_31,  bfd_mach_msp31},
+  {"msp430x323",   MSP430_ISA_32,  bfd_mach_msp32},
+  {"msp430x325",   MSP430_ISA_32,  bfd_mach_msp32},
+  {"msp430x336",   MSP430_ISA_33,  bfd_mach_msp33},
+  {"msp430x337",   MSP430_ISA_33,  bfd_mach_msp33},
+
+  {"msp430x412",   MSP430_ISA_41,  bfd_mach_msp41},
+  {"msp430x413",   MSP430_ISA_41,  bfd_mach_msp41},
+  {"msp430x415",   MSP430_ISA_41,  bfd_mach_msp41},
+  {"msp430x417",   MSP430_ISA_41,  bfd_mach_msp41},
+
+  {"msp430x423",   MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430x425",   MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430x427",   MSP430_ISA_42,  bfd_mach_msp42},
+
+  {"msp430x4250",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430x4260",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430x4270",  MSP430_ISA_42,  bfd_mach_msp42},
+
+  {"msp430xG4250", MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xG4260", MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xG4270", MSP430_ISA_42,  bfd_mach_msp42},
+
+  {"msp430xE423",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xE4232", MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xE4242", MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xE4252", MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xE425",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xE427",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xE4272", MSP430_ISA_42,  bfd_mach_msp42},
+
+  {"msp430xW423",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xW425",  MSP430_ISA_42,  bfd_mach_msp42},
+  {"msp430xW427",  MSP430_ISA_42,  bfd_mach_msp42},
+
+  {"msp430xG437",  MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430xG438",  MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430xG439",  MSP430_ISA_43,  bfd_mach_msp43},
+
+  {"msp430x435",   MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430x4351",  MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430x436",   MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430x4361",  MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430x437",   MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430x4371",  MSP430_ISA_43,  bfd_mach_msp43},
+  {"msp430x447",   MSP430_ISA_44,  bfd_mach_msp44},
+  {"msp430x448",   MSP430_ISA_44,  bfd_mach_msp44},
+  {"msp430x449",   MSP430_ISA_44,  bfd_mach_msp44},
+
+  {"msp430xG4616", MSP430_ISA_46,  bfd_mach_msp46},
+  {"msp430xG4617", MSP430_ISA_46,  bfd_mach_msp46},
+  {"msp430xG4618", MSP430_ISA_46,  bfd_mach_msp46},
+  {"msp430xG4619", MSP430_ISA_46,  bfd_mach_msp46},
+
+  {"msp430x4783",  MSP430_ISA_47,  bfd_mach_msp47},
+  {"msp430x4784",  MSP430_ISA_47,  bfd_mach_msp47},
+  {"msp430x4793",  MSP430_ISA_47,  bfd_mach_msp47},
+  {"msp430x4794",  MSP430_ISA_47,  bfd_mach_msp47},
+  
+  {"msp430x47166", MSP430_ISA_471, bfd_mach_msp471},
+  {"msp430x47176", MSP430_ISA_471, bfd_mach_msp471},
+  {"msp430x47186", MSP430_ISA_471, bfd_mach_msp471},
+  {"msp430x47196", MSP430_ISA_471, bfd_mach_msp471},
+
+  {"msp430x47167", MSP430_ISA_471, bfd_mach_msp471},
+  {"msp430x47177", MSP430_ISA_471, bfd_mach_msp471},
+  {"msp430x47187", MSP430_ISA_471, bfd_mach_msp471},
+  {"msp430x47197", MSP430_ISA_471, bfd_mach_msp471},
+
+  {"msp430x5418",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5419",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5435",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5436",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5437",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5438",  MSP430_ISA_54,  bfd_mach_msp54},
+
+  {"msp430x5510",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5513",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5514",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5515",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5517",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5519",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5521",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5522",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5524",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5525",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5526",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5527",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5528",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x5529",  MSP430_ISA_54,  bfd_mach_msp54},
+  {"msp430x6638",  MSP430_ISA_54,  bfd_mach_msp54},
+
+  {"cc430x5133",   MSP430_ISA_54,  bfd_mach_msp54},
+  {"cc430x5125",   MSP430_ISA_54,  bfd_mach_msp54},
+  {"cc430x6125",   MSP430_ISA_54,  bfd_mach_msp54},
+  {"cc430x6135",   MSP430_ISA_54,  bfd_mach_msp54},
+  {"cc430x6126",   MSP430_ISA_54,  bfd_mach_msp54},
+  {"cc430x5137",   MSP430_ISA_54,  bfd_mach_msp54},
+  {"cc430x6127",   MSP430_ISA_54,  bfd_mach_msp54},
+  {"cc430x6137",   MSP430_ISA_54,  bfd_mach_msp54},
 
   {NULL, 0, 0}
 };
 
 
-static struct mcu_type_s default_mcu =
+static struct mcu_type_s const default_mcu =
     { "msp430x11", MSP430_ISA_11, bfd_mach_msp11 };
 
-static struct mcu_type_s * msp430_mcu = & default_mcu;
+static struct mcu_type_s const * msp430_mcu = & default_mcu;
 
 /* Profiling capability:
    It is a performance hit to use gcc's profiling approach for this tiny target.
@@ -446,11 +618,14 @@ pow2value (int y)
 static char *
 parse_exp (char * s, expressionS * op)
 {
+  char * in_save = input_line_pointer;
   input_line_pointer = s;
   expression (op);
+  s = input_line_pointer;
+  input_line_pointer = in_save;
   if (op->X_op == O_absent)
     as_bad (_("missing operand"));
-  return input_line_pointer;
+  return s;
 }
 
 
@@ -504,7 +679,8 @@ extract_operand (char * from, char * to, int limit)
   *(to + size) = 0;
   del_spaces (to);
 
-  from++;
+  if(*from == ',')
+    from++;
 
   return from;
 }
@@ -549,7 +725,8 @@ msp430_profiler (int dummy ATTRIBUTE_UNUSED)
       return;
     }
 
-  input_line_pointer = extract_operand (input_line_pointer, flags, 32);
+  input_line_pointer = extract_operand (input_line_pointer, flags, 32)
+                        + 1;    // skip trailing zero
 
   while (*flags)
     {
@@ -662,7 +839,7 @@ msp430_profiler (int dummy ATTRIBUTE_UNUSED)
       /* Process like ".word xxx" directive.  */
       parse_exp (str, & exp);
       emit_expr (& exp, 2);
-      input_line_pointer = halt;
+      input_line_pointer = halt + 1;
     }
 
   /* Fill the rest with zeros.  */
@@ -766,11 +943,14 @@ md_parse_option (int c, char * arg)
   return 0;
 }
 
+static void
+msp430_repeat_insn (int dummy ATTRIBUTE_UNUSED);
 
 const pseudo_typeS md_pseudo_table[] =
 {
   {"arch", msp430_set_arch, 0},
   {"profiler", msp430_profiler, 0},
+  {"rpt", msp430_repeat_insn, 0},
   {NULL, NULL, 0}
 };
 
@@ -792,26 +972,57 @@ md_show_usage (FILE * stream)
   fprintf (stream,
 	   _("MSP430 options:\n"
 	     "  -mmcu=[msp430-name] select microcontroller type\n"
-	     "                  msp430x110  msp430x112\n"
-	     "                  msp430x1101 msp430x1111\n"
-	     "                  msp430x1121 msp430x1122 msp430x1132\n"
-	     "                  msp430x122  msp430x123\n"
-	     "                  msp430x1222 msp430x1232\n"
-	     "                  msp430x133  msp430x135\n"
-	     "                  msp430x1331 msp430x1351\n"
-	     "                  msp430x147  msp430x148  msp430x149\n"
-	     "                  msp430x155  msp430x156  msp430x157\n"
-	     "                  msp430x167  msp430x168  msp430x169\n"
-	     "                  msp430x1610 msp430x1611 msp430x1612\n"
-	     "                  msp430x311  msp430x312  msp430x313  msp430x314  msp430x315\n"
-	     "                  msp430x323  msp430x325\n"
-	     "                  msp430x336  msp430x337\n"
-	     "                  msp430x412  msp430x413  msp430x415  msp430x417\n"
-	     "                  msp430xE423 msp430xE425 msp430E427\n"
-	     "                  msp430xW423 msp430xW425 msp430W427\n"
-	     "                  msp430xG437 msp430xG438 msp430G439\n"
-	     "                  msp430x435  msp430x436  msp430x437\n"
-	     "                  msp430x447  msp430x448  msp430x449\n"));
+	     "                  msp430x110   msp430x112\n"
+	     "                  msp430x1101  msp430x1111  msp430x1121\n"
+	     "                  msp430x1122  msp430x1132\n"
+	     "                  msp430x122   msp430x123\n"
+	     "                  msp430x1222  msp430x1232\n"
+	     "                  msp430x133   msp430x135\n"
+	     "                  msp430x1331  msp430x1351\n"
+	     "                  msp430x147   msp430x148   msp430x149\n"
+	     "                  msp430x1471  msp430x1481  msp430x1491\n"
+	     "                  msp430x155   msp430x156   msp430x157\n"
+	     "                  msp430x167   msp430x168   msp430x169\n"
+	     "                  msp430x1610  msp430x1611  msp430x1612\n"
+	     "                  msp430x2001  msp430x2011\n"
+	     "                  msp430x2002  msp430x2012\n"
+	     "                  msp430x2003  msp430x2013\n"
+	     "                  msp430x2101  msp430x2111  msp430x2121  msp430x2131\n"
+	     "                  msp430x2112  msp430x2122  msp430x2132\n"
+	     "                  msp430x2232  msp430x2252  msp430x2272\n"
+	     "                  msp430x2234  msp430x2254  msp430x2274\n"
+	     "                  msp430x233   msp430x235\n"
+	     "                  msp430x2330  msp430x2350  msp430x2370\n"
+	     "                  msp430x247   msp430x248   msp430x249   msp430x2410\n"
+	     "                  msp430x2471  msp430x2481  msp430x2491\n"
+	     "                  msp430x2416  msp430x2417  msp430x2418  msp430x2419\n"
+	     "                  msp430x2616  msp430x2617  msp430x2618  msp430x2619\n"
+	     "                  msp430x311   msp430x312   msp430x313   msp430x314  msp430x315\n"
+	     "                  msp430x323   msp430x325\n" 
+	     "                  msp430x336   msp430x337\n"
+	     "                  msp430x412   msp430x413   msp430x415   msp430x417\n"
+	     "                  msp430x423   msp430x425   msp430427\n"
+	     "                  msp430x4250  msp430x4260  msp4304270\n"
+	     "                  msp430xE423  msp430xE425  msp430E427\n"
+	     "                  msp430xE4232 msp430xE4242 msp430xE4252 msp430E4272\n"
+	     "                  msp430xW423  msp430xW425  msp430W427\n"
+	     "                  msp430xG4250 msp430xG4260 msp430G4270\n"
+	     "                  msp430xG437  msp430xG438  msp430G439\n"
+	     "                  msp430x435   msp430x436   msp430x437\n"
+	     "                  msp430x4351  msp430x4361  msp430x4371\n"
+	     "                  msp430x447   msp430x448   msp430x449\n"
+	     "                  msp430xG4616 msp430xG4617 msp430xG4618 msp430xG4619\n"
+	     "                  msp430x4783  msp430x4784  msp430x4793  msp430x4794\n"
+	     "                  msp430x47166 msp430x47176 msp430x47186  msp430x47196\n"
+	     "                  msp430x47167 msp430x47177 msp430x47187  msp430x47197\n"
+	     "                  msp430x5418  msp430xG5419\n"
+	     "                  msp430x5435  msp430x5436  msp430x5437  msp430x5438\n"
+	     "                  cc430x5133\n"
+	     "                  cc430x5125   cc430x6125   cc430x6135\n"
+	     "                  cc430x6126\n"
+	     "                  cc430x5137   cc430x6127   cc430x6137\n"
+             
+             ));
   fprintf (stream,
 	   _("  -mQ - enable relaxation at assembly time. DANGEROUS!\n"
 	     "  -mP - enable polymorph instructions\n"));
@@ -851,7 +1062,7 @@ md_atof (int type, char * litP, int * sizeP)
 void
 md_begin (void)
 {
-  struct msp430_opcode_s * opcode;
+  struct msp430_opcode_s const * opcode;
   msp430_hash = hash_new ();
 
   for (opcode = msp430_opcodes; opcode->name; opcode++)
@@ -881,10 +1092,63 @@ check_reg (char * t)
   return 0;
 }
 
+static void 
+msp430_substitute_CG(struct msp430_operand_s * op, int workaround)
+{
+  /* Substitute register mode with a constant generator if applicable.  */
+  if( op->mode != OP_EXP || ( op->exp.X_op != O_constant && op->exp.X_op != O_big ))
+    return;
+  if( op->am != 3 || op->reg != 0 )     // not #N
+    return;
+  int x = (short) op->exp.X_add_number;	/* Extend sign.  */
+
+  if (x == 0)
+    {
+      op->reg = 3;
+      op->am = 0;
+      op->ol = 0;
+      op->mode = OP_REG;
+    }
+  else if (x == 1)
+    {
+      op->reg = 3;
+      op->am = 1;
+      op->ol = 0;
+      op->mode = OP_REG;
+    }
+  else if (x == 2)
+    {
+      op->reg = 3;
+      op->am = 2;
+      op->ol = 0;
+      op->mode = OP_REG;
+    }
+  else if (x == -1)
+    {
+      op->reg = 3;
+      op->am = 3;
+      op->ol = 0;
+      op->mode = OP_REG;
+    }
+  else if (x == 4 && !workaround)
+    {
+      op->reg = 2;
+      op->am = 2;
+      op->ol = 0;
+      op->mode = OP_REG;
+    }
+  else if (x == 8 && ! workaround)
+    {
+      op->reg = 2;
+      op->am = 3;
+      op->ol = 0;
+      op->mode = OP_REG;
+    }
+}
 
 static int
 msp430_srcoperand (struct msp430_operand_s * op,
-		   char * l, int bin, int * imm_op)
+		   char * l, int * imm_op, int imm_min, int imm_max)
 {
   char *__tl = l;
 
@@ -965,79 +1229,11 @@ msp430_srcoperand (struct msp430_operand_s * op,
 	      x = op->exp.X_add_number;
 	    }
 
-	  if (op->exp.X_add_number > 65535 || op->exp.X_add_number < -32768)
-	    {
-	      as_bad (_("value %d out of range. Use #lo() or #hi()"), x);
+        if (x >= imm_max || x < imm_min)
+        {
+	      as_bad (_("value %d out of %d...%d (0x%X...0x%X) range."), x, imm_min, imm_max - 1, imm_min, imm_max - 1);
 	      return 1;
 	    }
-
-	  /* Now check constants.  */
-	  /* Substitute register mode with a constant generator if applicable.  */
-
-	  x = (short) x;	/* Extend sign.  */
-
-	  if (x == 0)
-	    {
-	      op->reg = 3;
-	      op->am = 0;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
-	  else if (x == 1)
-	    {
-	      op->reg = 3;
-	      op->am = 1;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
-	  else if (x == 2)
-	    {
-	      op->reg = 3;
-	      op->am = 2;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
-	  else if (x == -1)
-	    {
-	      op->reg = 3;
-	      op->am = 3;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
-	  else if (x == 4)
-	    {
-#ifdef PUSH_1X_WORKAROUND
-	      if (bin == 0x1200)
-		{
-		  /* Remove warning as confusing.
-		     as_warn (_("Hardware push bug workaround")); */
-		}
-	      else
-#endif
-		{
-		  op->reg = 2;
-		  op->am = 2;
-		  op->ol = 0;
-		  op->mode = OP_REG;
-		}
-	    }
-	  else if (x == 8)
-	    {
-#ifdef PUSH_1X_WORKAROUND
-	      if (bin == 0x1200)
-		{
-		  /* Remove warning as confusing.
-		     as_warn (_("Hardware push bug workaround")); */
-		}
-	      else
-#endif
-		{
-		  op->reg = 2;
-		  op->am = 3;
-		  op->ol = 0;
-		  op->mode = OP_REG;
-		}
-	    }
 	}
       else if (op->exp.X_op == O_symbol)
 	{
@@ -1045,12 +1241,10 @@ msp430_srcoperand (struct msp430_operand_s * op,
 	}
       else if (op->exp.X_op == O_big)
 	{
-	  short x;
 	  if (vshift != -1)
 	    {
 	      op->exp.X_op = O_constant;
 	      op->exp.X_add_number = 0xffff & generic_bignum[vshift];
-	      x = op->exp.X_add_number;
 	    }
 	  else
 	    {
@@ -1059,49 +1253,6 @@ msp430_srcoperand (struct msp430_operand_s * op,
 		      l);
 	      return 1;
 	    }
-
-	  if (x == 0)
-	    {
-	      op->reg = 3;
-	      op->am = 0;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
-	  else if (x == 1)
-	    {
-	      op->reg = 3;
-	      op->am = 1;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
-	  else if (x == 2)
-	    {
-	      op->reg = 3;
-	      op->am = 2;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
-	  else if (x == -1)
-	    {
-	      op->reg = 3;
-	      op->am = 3;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
-	  else if (x == 4)
-	    {
-	      op->reg = 2;
-	      op->am = 2;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
-	  else if (x == 8)
-	    {
-	      op->reg = 2;
-	      op->am = 3;
-	      op->ol = 0;
-	      op->mode = OP_REG;
-	    }
 	}
       /* Redundant (yet) check.  */
       else if (op->exp.X_op == O_register)
@@ -1128,7 +1279,7 @@ msp430_srcoperand (struct msp430_operand_s * op,
 	{
 	  int x = op->exp.X_add_number;
 
-	  if (x > 65535 || x < -32768)
+          if (x >= imm_max || x < imm_min)
 	    {
 	      as_bad (_("value out of range: %d"), x);
 	      return 1;
@@ -1263,7 +1414,7 @@ msp430_srcoperand (struct msp430_operand_s * op,
 	{
 	  int x = op->exp.X_add_number;
 
-	  if (x > 65535 || x < -32768)
+          if (x > imm_max || x < imm_min)
 	    {
 	      as_bad (_("value out of range: %d"), x);
 	      return 1;
@@ -1339,10 +1490,10 @@ msp430_srcoperand (struct msp430_operand_s * op,
 
 
 static int
-msp430_dstoperand (struct msp430_operand_s * op, char * l, int bin)
+msp430_dstoperand (struct msp430_operand_s * op, char * l, int imm_min, int imm_max)
 {
   int dummy;
-  int ret = msp430_srcoperand (op, l, bin, & dummy);
+  int ret = msp430_srcoperand (op, l, & dummy, imm_min, imm_max);
 
   if (ret)
     return ret;
